"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotCommandUploader = void 0;
class BotCommandUploader {
    constructor(api) {
        this.api = api;
    }
    async upload(list) {
        let commandList = list.get();
        for (let { language, commands: languageCommands } of commandList) {
            let commands = languageCommands.flatMap(cmd => cmd.bodies);
            let scopes = languageCommands.map(cmd => cmd.scope);
            if (await this.checkActuality(language, commands, scopes)) {
                continue;
            }
            await this.api.callMethod("setMyCommands", {
                commands,
                scope: scopes,
                language_code: language
            });
        }
    }
    async checkActuality(lang, commands, scopes) {
        let { result } = await this.api.callMethod("getMyCommands", {
            scope: scopes,
            language_code: lang
        });
        return result.length > 0 && result.every(resCmd => commands.some(cmd => cmd.command === resCmd.command && cmd.description === resCmd.description));
    }
}
exports.BotCommandUploader = BotCommandUploader;
